HSRN Dashboard application
==========================

This is the HSRN dashboard web application. It uses TypeScript, Next.js, Knex.js, and Auth0.

Development setup
-----------------

* Copy `.env.sample` to `.env.local`, fill in the values
* Run `npm install`
* Initialize the database using `npx knex migrate:latest` (default: `test.sqlite3`)
* (optional) Load the test data using `npx knex seed:run`
* Run the server using `npm run dev`

Before committing changes, use `npm run fix` to format the code automatically.

### How to set up Keycloak

You can use Keycloak as an OIDC provider. This allows you to run the app without creating a CILogon or Auth0 account.

You can run Keycloak like this:

```
docker run -p 8080:8080 -e KEYCLOAK_ADMIN=admin -e KEYCLOAK_ADMIN_PASSWORD=admin quay.io/keycloak/keycloak:19.0.3
```

Then go to [http://localhost:8080/](http://localhost:8080) and login with username `admin` and password `admin`. Create a new realm for example `hsrn`.

In that realm, create a new client for example `kubernetes` (client type "OpenID Connect"). Set the redirect URI to `http://localhost:3000/api/auth/callback`. Under the "credentials" tab, get your client secret.

Create users as required for your tests. If you intend to test logging in with them, set a password under the "credentials" tab.

You can then use a configuration like this (in `.env.local`):

```
AUTH0_SECRET=replace-with-your-own-secret-generated-with-openssl # Get a more secret string with: openssl rand -base64 48
AUTH0_ISSUER_BASE_URL='http://localhost:8080/realms/hsrn'
AUTH0_CLIENT_ID='kubernetes'
AUTH0_CLIENT_SECRET='string-from-keycloak-realm-tab-credentials'
```
