import {sortByKey, sortedByKey, sortByKeys, sortedByKeys} from '../lib/utils';

test('sortByKey', () => {
  const arr1 = [13, 21, 32, 44];
  sortByKey(arr1, (t: number) => t % 10);
  expect(arr1).toEqual([21, 32, 13, 44]);

  const arr2 = [13, 21, 32, 44];
  sortByKey(arr2, (t: number) => -(t % 10));
  expect(arr2).toEqual([44, 13, 32, 21]);
});

test('sortedByKey', () => {
  const arr1 = [13, 21, 32, 44];
  const arr1r = sortedByKey(arr1, (t: number) => t % 10);
  expect(arr1).toEqual([13, 21, 32, 44]);
  expect(arr1r).toEqual([21, 32, 13, 44]);

  const arr2 = [13, 21, 32, 44];
  const arr2r = sortedByKey(arr2, (t: number) => -(t % 10));
  expect(arr2).toEqual([13, 21, 32, 44]);
  expect(arr2r).toEqual([44, 13, 32, 21]);
});

test('sortByKeys', () => {
  const arr1 = [34, 13, 12, 33, 41, 23];
  const arr1r = sortedByKeys(arr1, (t: number) => [t % 10, Math.floor(t / 10)]);
  expect(arr1).toEqual([34, 13, 12, 33, 41, 23]);
  expect(arr1r).toEqual([41, 12, 13, 23, 33, 34]);
  sortByKeys(arr1, (t: number) => [t % 10, -Math.floor(t / 10)]);
  expect(arr1).toEqual([41, 12, 33, 23, 13, 34]);
});
