import Head from 'next/head';
import Link from 'next/link';
import {User} from '../database/models';

export interface LayoutProps {
  title?: string;
  user: User | null;
  children: React.ReactNode;
}

export function Layout(props: LayoutProps) {
  let title = 'HSRN Dashboard';
  if (props.title) {
    title = props.title + ' - HSRN Dashboard';
  }
  let navbar;
  if (props.user) {
    navbar = (
      <>
        {props.user.name} <Link href="/api/auth/logout">Logout</Link>
      </>
    );
  }
  navbar = (
    <div id="navbar">
      <Link href="/">Dashboard</Link> {navbar}
    </div>
  );
  return (
    <>
      <Head>
        <title>{title}</title>
      </Head>
      {navbar}
      {props.children}
    </>
  );
}
