export interface OidcApp {
  clientId: string;
  clientSecret: string;
  issuerUrl: string;
}

export interface OidcUser {
  userId: string;
  refreshToken: string;
  accessToken: string;
  idToken: string;
}

export function kubeconfig(app: OidcApp, user: OidcUser): string {
  return `apiVersion: v1
clusters:
- cluster:
    server: https://api.hsrn.nyu.edu
  name: hsrn
contexts:
- context:
    cluster: hsrn
    namespace: hsrn
    user: ${user.userId}
  name: hsrn
current-context: hsrn
kind: Config
preferences: {}
users:
- name: ${user.userId}
  user:
    auth-provider:
      config:
        client-id: ${app.clientId}
        client-secret: ${app.clientSecret}
        id-token: ${user.idToken}
        idp-issuer-url: ${app.issuerUrl}
        refresh-token: ${user.refreshToken}
      name: oidc`;
}
