export function sorted<T>(arr: Array<T>): Array<T> {
  const ret = Array.from(arr);
  ret.sort();
  return ret;
}

export function sortByKey<T>(arr: Array<T>, f: (e: T) => any) {
  arr.sort((a, b) => {
    const ka = f(a),
      kb = f(b);
    if (ka === kb) {
      return 0;
    } else if (ka > kb) {
      return 1;
    } else {
      return -1;
    }
  });
}

export function sortedByKey<T>(arr: Array<T>, f: (e: T) => any): Array<T> {
  const ret = Array.from(arr);
  sortByKey(ret, f);
  return ret;
}

export function sortByKeys<T>(arr: Array<T>, f: (e: T) => any[]) {
  arr.sort((a, b) => {
    const aa = f(a),
      ab = f(b);
    for (let i = 0; i < aa.length && i < ab.length; ++i) {
      const ka = aa[i],
        kb = ab[i];
      if (ka > kb) {
        return 1;
      } else if (ka < kb) {
        return -1;
      }
    }
    if (aa.length === ab.length) {
      return 0;
    } else if (aa.length > ab.length) {
      return 1;
    } else {
      return -1;
    }
  });
}

export function sortedByKeys<T>(arr: Array<T>, f: (e: T) => any[]): Array<T> {
  const ret = Array.from(arr);
  sortByKeys(ret, f);
  return ret;
}
